/*
 * Device Driver for DataTranslation DT2801
 *
 * $Id: dt2801_adc.h,v 1.2 1996/03/13 09:36:42 martin Exp $
 * $Source: /home/martin/Software/DAQ/drivers/dt2801/RCS/dt2801_adc.h,v $
 *
 *
 * $Log: dt2801_adc.h,v $
 * Revision 1.2  1996/03/13 09:36:42  martin
 * Fake mode, cleanup, DMA-mode
 *
 * Revision 1.1  1996/03/04  07:20:12  martin
 * Initial revision
 *
 *
 */

#ifndef _DT2801_ADC_H
#define _DT2801_ADC_H 1

#ifdef __KERNEL__

/* A/D-converter */

#define DT2801_NUM_ADCS 1
#define DT2801_ADC_CHANNELS 8

/* Minor device numbers */
#define DT2801_ADC      0x10

#define DT2801_ADC_UNIPOLAR 0
#define DT2801_ADC_BIPOLAR  1

#define DT2801_ADC_DIFFERENTIAL 0
#define DT2801_ADC_SINGLE_ENDED 1


typedef struct {
    int inuse;

    int polarity;

    int channel;

    int startch;
    int endch;
    int gain;

    unsigned int conv;
    int mode;

    int last;
    int currnt;
    int running;
    int cnt;

    int blocksize;

    int dmabufsize;
    void* dmabuf;

} Dt2801_ADC_t;

extern struct file_operations dt2801_adc_fops;
extern int dt2801_adc_init(void);
extern int dt2801_adc_cleanup(void);

#endif /* __KERNEL__ */

#define DT2801_ADC_IMMEDIATE  1
#define DT2801_ADC_BLOCK      2

#define DT2801_IOCTL_ADC_SET_PARAMS 0x11
#define DT2801_IOCTL_ADC_SET_MODE   0x12
#define DT2801_IOCTL_ADC_BLOCKSTART 0x13
#define DT2801_IOCTL_ADC_BLOCKSTOP  0x14
#define DT2801_IOCTL_ADC_RESIDUE    0x15
#define DT2801_IOCTL_ADC_POLARITY   0x16

typedef struct {
    int startch;
    int endch;
    int gain;
    unsigned int conv;
} Dt2801_ADCP_t;

#endif /* _dt2801_adc_h_ */
