/*
 * Device Driver for DataTranslation DT2801
 *
 * $Id: dt2801_dac.h,v 1.1 1996/03/04 07:20:59 martin Exp martin $
 * $Source: /home/martin/Software/DAQ/drivers/dt2801/RCS/dt2801_dac.h,v $
 *
 *
 * $Log: dt2801_dac.h,v $
 * Revision 1.1  1996/03/04 07:20:59  martin
 * Initial revision
 *
 *
 */

#ifndef _DT2801_DAC_H
#define _DT2801_DAC_H 1
#ifdef __KERNEL__

/*
 * DAC
 */
/* There are 2 DAC-channels (12-bit reslution), which can be configured
   separately. Either unipolar output (0..5V / 0..10V full-scale), or
   bipolar output (-2.5..+2.5V / -5.0..+5.0 / -10.0..+10.0).
   This is done with jumpers, so not configurable at runtime.
*/

#define DT2801_DAC_UNIPOLAR 0
#define DT2801_DAC_BIPOLAR  1

#define DT2801_DAC_BITS 12

#define DT2801_NUM_DACS 2

typedef struct {
    int range;
    int polarity;

    int mode;
    unsigned int conv;
} Dt2801_DAC_t;

/* Minor device numbers */
#define DT2801_DAC0     0x20
#define DT2801_DAC1     0x21

extern struct file_operations dt2801_dac_fops;
extern int dt2801_dac_init(void);
extern int dt2801_dac_cleanup(void);
extern int dt2801_dac_reset(void);

#endif /* __KERNEL__ */

#define DT2801_DAC_IMMEDIATE 1
#define DT2801_DAC_BLOCK     2

#define DT2801_IOCTL_DAC_SET_PARAMS 0x21
#define DT2801_IOCTL_DAC_SET_MODE   0x22

typedef struct {
    unsigned int conv;
} Dt2801_DACP_t;

#endif /* _DT2801_DAC_H */
