/*
 * Device Driver for DataTranslation DT2801
 *
 * $Id: dt2801_dio.c,v 1.2 1996/03/13 09:38:25 martin Exp martin $
 * $Source: /home/martin/Software/DAQ/drivers/dt2801/RCS/dt2801_dio.c,v $
 *
 *
 * $Log: dt2801_dio.c,v $
 * Revision 1.2  1996/03/13 09:38:25  martin
 * Disabeled for the moment
 *
 * Revision 1.1  1996/03/04 07:21:11  martin
 * Initial revision
 *
 *
 */

#include <linux/errno.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/tty.h>
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/major.h>
#include <linux/malloc.h>
#include <linux/timer.h>
#include <linux/fcntl.h>

#include <asm/io.h>
#include <asm/segment.h>
#include <asm/system.h>
#include <asm/dma.h>

#ifdef MODULE
#include <linux/version.h>
#else
#error "dt2801_dio must be compiled as a module"
#endif

#include "dt2801.h"
#include "dt2801_dio.h"


static Dt2801_DIO_t dio;
static Dt2801_DIO_ACC_t dio_acc[DT2801_DIO_MAX_OPEN];


static int lines2port(uint lines)
{
    int port = 0;

    if (lines & 0xff ) {
        port |= 1;
    }
    if (lines &0xff00) {
        port |= 2;
    }
    
    DT_PRINTK("dt2801: lines2port port = %d\n", port);

    return port;
}

static int find_acc_entry(struct file* filp)
{
    int i;

    for (i=0; i<DT2801_DIO_MAX_OPEN; i++) {
        if (dio_acc[i].filp == filp) {
            return i;
        }
    }
    return -1;
}

static int new_acc_entry(void)
{
    int i;

    for (i=0; i<DT2801_DIO_MAX_OPEN; i++) {
        if (dio_acc[i].filp == NULL) {
            return i;
        }
    }
    return -1;
}

static int dt2801_do_write(void)
{
/*
    int i, port;

    for (i=0; i<DT2801_NUM_DIO_PORTS;i++) {
      dt2801_writecommand(DT_C_WRITE_DIG);
      dt2801_writedata(port);
      dt2801_writedata2(databyte);
    }

    if (dt2801->dioports[port].mode != DT2801_DIO_WRITE)
             {
                 dprintk(( "dt2801_dio_write: set mode to write.\n" ));
                 dt2801_writecommand(DT_C_SET_DIGOUT);
                 dt2801_writedata(port);
                 dt2801->dioports[port].mode = DT2801_DIO_WRITE;
                 dt2801->dioports[0].mode = DT2801_DIO_WRITE;
                 dt2801->dioports[1].mode = DT2801_DIO_WRITE;
             }
*/


     /*
        case 0:
        case 1:
             port_size = 1;
             if (count!=port_size) return -EINVAL;
             if ((stat = verify_area(VERIFY_READ, buffer, port_size)) != 0)
                 return stat;
             databyte = (int) get_fs_byte(buffer);
             dprintk(( "dt2801_dio_write: databyte = %d.\n", databyte ));

             if (dt2801->dioports[port].mode != DT2801_DIO_WRITE)
             {
                 dprintk(( "dt2801_dio_write: set mode to write.\n" ));
                 dt2801_writecommand(DT_C_SET_DIGOUT);
                 dt2801_writedata(port);
                 dt2801->dioports[port].mode = DT2801_DIO_WRITE;
                 dt2801->dioports[2].mode = DT2801_DIO_UNDEFINED;
             }

             dt2801_writecommand(DT_C_WRITE_DIG);
             dt2801_writedata(port);
             dt2801_writedata(databyte);

            break;

        case 2:
             port_size = 2;
             if (count!=port_size) return -EINVAL;
             if ((stat = verify_area(VERIFY_READ, buffer, port_size)) != 0)
                 return stat;
             memcpy_fromfs(&databyte, buffer, port_size);
             dprintk(( "dt2801_dio_write: databyte = %d.\n", databyte ));

         

            break;

        default:
            dprintk(( "dt2801_dio_write: illegal port = %d.\n", port ));
            return -EINVAL;
    }
    */

    return 0;
}

/* later when I have time and 'write' is done */
static int dt2801_dio_read(struct inode *inode, struct file *file,
                       char* buffer, int count)
{
    return 0;
}

static int dt2801_dio_write(struct inode *inode, struct file *file,
                       char* buffer, int count)
{
    int entry;

    int minor = MINOR(inode->i_rdev);
    int port = minor & 0x3;


    dprintk(( "dt2801_dio_write: minor = %d  port = %d.\n", minor, port ));

    entry = find_acc_entry(file);
    if (entry <0) {
      DT_PRINTK("dt2801: write , no entry\n");
    }

    


    return count;
}

static int dt2801_dio_ioctl(struct inode *inode, struct file *file,
                       unsigned int cmd, unsigned long arg)
{

    int i;
    int minor = MINOR(inode->i_rdev);

    DT_PRINTK("dt2801_dio_ioctl: cmd = %d.\n", cmd);

    switch (cmd)
    {
        case DT2801_IOCTL_DIO_SET_LINES: {
                uint16 lines;
                int entry;
                int port;

                lines = (uint16) arg;
                DT_PRINTK("dt2801: ioctl_setlines lines = 0x%0x.\n", lines);

                if (lines == 0) {
                    return -(EINVAL);
                }

                if (minor != DT2801_DIO0) {
                    return -(EINVAL);
                }
		entry = find_acc_entry(file);
		if (entry <0) {
		    DT_PRINTK("dt2801_dio: ioctl , no entry\n");
		}
                if (dio.inuse & lines) {
                    DT_PRINTK("dt2801:ioctl_setlines a line is alrady in use.\n");
                    return  -(EBUSY);
                }

                port = lines2port(lines);
                if (port == 0 || port > 3) {
                    DT_PRINTK("dt2801:ioctl_setlines invalid port = %d.\n", port);
                    return -(EINVAL);
                }

                dio.port_count[port]++;
                dio_acc[entry].lines = lines;
                dio_acc[entry].port = port;
                
                DT_PRINTK("dt2801: ioctl_setlines inuse = 0x%0x.\n", dio.inuse);
                dio.inuse |= lines;
                DT_PRINTK("dt2801: ioctl_setlines inuse = 0x%0x.\n", dio.inuse);

		for (i=0; i<DT2801_NUM_DIO_PORTS;i++) {
		  DT_PRINTK("dt2801: release port_count %d .\n", dio.port_count[i]);
		}

            }
            break;
        default:
             return dt2801_ioctl(inode, file, cmd, arg);
    }
    return 0;
}



/* After board-reset or power-up */
int dt2801_dio_reset(void)
{
  /* dio.accessmode = 0; */ /* data input */
    return 0;
}

int dt2801_dio_cleanup(void)
{

    return 0;
}

int dt2801_dio_init()
{
    int i;

    dio.inuse = 0;
    dio.portmode =  0;
    dio.portstate=  0;

    for (i=0; i<DT2801_NUM_DIO_PORTS; i++) {
        dio.port_count[i] = 0;
        dio.ports[i] = 0;
    }
    for (i=0; i<DT2801_DIO_MAX_OPEN; i++) {
        dio_acc[i].inuse = 0;
        dio_acc[i].lines = 0;
        dio_acc[i].mode = 0;
        dio_acc[i].filp = NULL;
    }

    return 0;
}

int dt2801_dio_open(struct inode *inode, struct file *file)
{
    int minor = MINOR(inode->i_rdev);
    int port = minor & 0x3;
    int mode;
    uint16 lines = 0;
    int entry;

    DT_PRINTK("dt2801_dio:open minor = % d  port = %d.\n", minor, port);
    DT_PRINTK("dt2801: open f_flags =  0x%0x.\n", file->f_flags);

    switch (minor) {
        case DT2801_DIO0: {
            lines = 0x0000;
	    mode = file->f_flags & O_ACCMODE;
            if (mode == O_RDWR) {
                return -(EINVAL);
            }
	    entry = new_acc_entry();
	    if (entry < 0) {
	        return -(ENOMEM);
	        DT_PRINTK("dt2801_dio: open no entry.\n");
	    }
	    dio_acc[entry].filp = file;
	    dio_acc[entry].lines = lines;
	    dio_acc[entry].mode = mode;
            break;
        }
        default: return -(EINVAL);
    }

    DT_PRINTK("dt2801: open inuse 0x%0x.\n", dio.inuse);
/*
    DT_PRINTK("dt2801: open portmode = 0x%0x.\n", dio.portmode);
    DT_PRINTK("dt2801: open portstate = 0x%0x.\n", dio.portstate);
*/

    return 0;
}

static void dt2801_dio_release(struct inode *inode, struct file *file)
{
    int minor = MINOR(inode->i_rdev);
    int entry;
    int i;

    DT_PRINTK("dt2801_dio_release: minor = % d.\n", minor);

    entry = find_acc_entry(file);
    if (entry <0) {
        DT_PRINTK("dt2801: release , no entry\n");
    }
    DT_PRINTK("dt2801_dio_release: entry = % d.\n", entry);

    dio.portmode =   0;

    DT_PRINTK("dt2801: release inuse 0x%0x.\n", dio.inuse);
    DT_PRINTK("dt2801: release lines 0x%0x.\n", dio_acc[entry].lines);
    dio.inuse = ~dio_acc[entry].lines & dio.inuse;
    dio.port_count[dio_acc[entry].port]--;

    dio_acc[entry].inuse = 0;
    dio_acc[entry].filp = NULL;
    dio_acc[entry].lines = 0;
    dio_acc[entry].port = 0;
    dio_acc[entry].mode = 0;


    DT_PRINTK("dt2801: release inuse 0x%0x.\n", dio.inuse);
    for (i=0; i<DT2801_NUM_DIO_PORTS;i++) {
         DT_PRINTK("dt2801: release port_count %d .\n", dio.port_count[i]);
    }

    dt2801_release(inode, file);
}

struct file_operations dt2801_dio_fops = {
    NULL,                /* seek */
    dt2801_dio_read,     /* read */
    dt2801_dio_write,    /* write */
    NULL,                /* readdir */
    NULL,                /* select */
    dt2801_dio_ioctl,    /* ioctl */
    NULL,                /* mmap */
    dt2801_open,         /* open */       /* !!! */
    dt2801_dio_release   /* release */
};

/*

        case DT2801_DIO1: { lines = 0x00FF; break; }    
        case DT2801_DIO2: { lines = 0xFF00; break; }
        case DT2801_DIO3: { lines = 0xFFFF; break; }

    DT_PRINTK("dt2801: open inuse 0x%0x.\n", dio.inuse);
    DT_PRINTK("dt2801: open lines = 0x%0x.\n", lines);
    if (dio.inuse & lines )
    {
        DT_PRINTK("dt2801_dio:open device busy.\n");
        return -(EBUSY);
    }


    switch (file->f_flags & O_ACCMODE) {
        case O_RDONLY: { 
          if ( port) {
              DT_PRINTK("dt2801: open cannot read.\n");
              return -(EBUSY);
          }
          dio.portmode   |= ~port;
          dio.portstate  |= port;
          break;
        }
        case O_WRONLY: {
          if ( port) {
              DT_PRINTK("dt2801: open cannot write.\n");
              return -(EBUSY);
          }
          dio.portmode   |= port;
          dio.portstate  |= port;
          break;
        }
        case O_RDWR:   {
          return -(EINVAL);
          break;
        }
        default: { return -(EINVAL); }
    }

    entry = new_acc_entry();
    if (entry < 0) {
        return -(ENOMEM);
	DT_PRINTK("dt2801_dio: open no entry.\n");
    }

    dio_acc[entry].filp = file;
    dio_acc[entry].mode = file->f_flags & O_ACCMODE;
    dio.inuse |= lines;
*/
