/*
 * Device Driver for DataTranslation DT2801
 *
 * $Id: dt2801_dio.h,v 1.1 1996/03/04 07:21:22 martin Exp martin $
 * $Source: /home/martin/Software/DAQ/drivers/dt2801/RCS/dt2801_dio.h,v $
 *
 *
 * $Log: dt2801_dio.h,v $
 * Revision 1.1  1996/03/04 07:21:22  martin
 * Initial revision
 *
 *
 */

#ifndef _DT2801_DIO_H
#define _DT2801_DIO_H 1
#ifdef __KERNEL__

#define DT2801_NUM_DIO_PORTS 2  /* do not change, the bitmasks 'inuse' and
                                    accessmode depend on it  !! */
#define DT2801_DIO_PORTSIZE 8 
#define DT2801_DIO_MAX_OPEN (DT2801_NUM_DIO_PORTS*DT2801_DIO_PORTSIZE)

/* Minor device numbers */
#define DT2801_DIO0     0x30  /* the generic dio-device */
#define DT2801_DIO1     0x31  /* port 0, 8-bit */
#define DT2801_DIO2     0x32  /* port 1, 8-bit */
#define DT2801_DIO3     0x33  /* port 0 and 1 treated as one 16-bit port */


#include "dt2801defs.h"

/* To manage 2 8-bit ports */

typedef struct {
    uint16 inuse;
    uint16 accessmode;
    int portmode;
    int portstate;
    int port_count[DT2801_NUM_DIO_PORTS]; /* ref-count */
    uint16 ports[DT2801_NUM_DIO_PORTS]; /* keeps track of the state of dio-lines */
} Dt2801_DIO_t;

typedef struct {
    int inuse;
    struct file* filp;
    uint16 lines;
    int port;
    int mode;
} Dt2801_DIO_ACC_t;

extern struct file_operations dt2801_dio_fops;
extern int dt2801_dio_open(struct inode*, struct file *);
extern int dt2801_dio_init(void);
extern int dt2801_dio_cleanup(void);
extern int dt2801_dio_reset(void);

/*
#define DT2801_DIO_READ 0
#define DT2801_DIO_WRITE 1
#define DT2801_DIO_UNDEFINED -1
*/

#endif /* __KERNEL__ */

#define DT2801_IOCTL_DIO_SET_LINES 0x31

#endif /* _DT2801_DIO_H */
